Imports System
Imports System.Data
Imports System.Data.OleDb
Imports System.Collections
Public Class CAccessDatabase
    
    Private m_strConnect As String
    Private myConnection As OleDbConnection = Nothing
    Private mySQL As String = Nothing
    Private myConnectFlag As Boolean = False
    Public Property connectString() As String
        Get
            
            Return m_strConnect
        End Get
        Set
            m_strConnect = value
        End Set
    End Property
    
    Public Sub New()
        MyBase.New()
    End Sub
    Public Sub New(ByRef strConnect As String)
        MyBase.New()
        m_strConnect = strConnect
    End Sub
    Public Function Connect() As Boolean
        Try
            myConnection = New OleDbConnection(m_strConnect)
            myConnection.Open()
            'myConnectFlag = GrantReadAccessToSysObjects()
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        Return myConnectFlag
    End Function
    Private Function GrantReadAccessToSysObjects() As Boolean
        Dim success As Boolean = False
        Try
            Dim SQL As String = "GRANT SELECT ON TABLE MSysObjects TO Admin"
            Dim myCommand As OleDbCommand = New OleDbCommand(SQL, myConnection)
            myCommand.ExecuteNonQuery()
            success = True
        Catch e As OleDbException
            Console.WriteLine(e.Message)
        End Try
        Return success
    End Function

    Private Function GetTables(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT [Name] FROM MSysObjects WHERE Type=1 And Left([Name],1)<>'~' And Left([Name],4) <> 'MSys' Order By [Name]"
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                mySuccessFlag = True
                'Need to use the DataColumn to get the Schema
                'myConnection.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, )
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try

        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function

    Public Function myDatabaseTables(ByRef myTableDataSet As DataSet) As Boolean
        Dim myLocalTableDataSet As DataSet = New DataSet()
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                Dim myDataReader As OleDbDataReader
                Dim successFlag As Boolean = False
                successFlag = GetTables(myDataReader)
                If (successFlag) Then
                    Dim myArrayList As ArrayList = New ArrayList()
                    While (myDataReader.Read())
                        Dim myTableName As String = ""
                        myTableName = CType(myDataReader.GetValue(0), String)
                        myArrayList.Add(myTableName)
                    End While
                    myDataReader.Close()
                    Dim iArrayCount As Integer = myArrayList.Count
                    Dim myTableArray(iArrayCount) As String
                    myArrayList.CopyTo(myTableArray)
                    Dim i As Integer
                    For i = 0 To iArrayCount - 1
                        Dim tblName As String
                        tblName = myTableArray(i)
                        mySQL = "SELECT * FROM [" + tblName + "] WHERE False"
                        Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                        Dim myDataSetCommand As OleDbDataAdapter = New OleDbDataAdapter(myCommand)
                        myDataSetCommand.Fill(myLocalTableDataSet, tblName)
                    Next
                End If
                myTableDataSet = myLocalTableDataSet
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myTableDataSet = myLocalTableDataSet
        Return mySuccessFlag
    End Function
    Public Function GetQueries(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT [Name] FROM MSysObjects WHERE Type=5 And Left([Name],1)<>'~' And Mid([Name], Len([Name]) - 3) <> '0000' Order By [Name]"
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult) '(mylocalDataReader)
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function GetMacros(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT [Name] FROM MSysObjects WHERE Type=-32766 And Left([Name],1)<>'~' Order By [Name]"
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function GetModules(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT [Name] FROM MSysObjects WHERE Type=-32761 And Left([Name],1)<>'~' Order By [Name]"
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function GetReports(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT [Name] FROM MSysObjects WHERE Type=-32764 And Left([Name],1)<>'~' Order By [Name]"
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function GetForms(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT [Name] FROM MSysObjects WHERE Type=-32768 And Left([Name],1)<>'~' Order By [Name]"
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Sub Close()
        If (myConnectFlag) Then
            myConnection.Close()
        End If
    End Sub
    Public Function ExecuteSQL(ByRef mySQL As String, ByRef myDataSet As DataSet, ByRef mySQLError As String) As Boolean
        Dim mylocalDataSet As DataSet = New DataSet()
        Dim mylocalError As String = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                Dim myDataSetCommand As OleDbDataAdapter = New OleDbDataAdapter(myCommand)
                myDataSetCommand.Fill(mylocalDataSet, "temp")
                mySuccessFlag = True
            Else

                mylocalError = "[Connection Failed]: Invalid Connection parameters."
            End If
        Catch e As OleDbException
            Dim myError As OleDbError
            For Each myError In e.Errors
                mylocalError += "[Error Source]: " + myError.Source + "[Error Message]: " + myError.Message
            Next
        Finally
            mySQLError = mylocalError
            myDataSet = mylocalDataSet
        End Try
        Return mySuccessFlag
    End Function

End Class
