VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DirectCad 1.0  F. Guerrazzi"
   ClientHeight    =   7335
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   8190
   LinkTopic       =   "Form1"
   ScaleHeight     =   7335
   ScaleWidth      =   8190
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command7 
      Caption         =   "-"
      Height          =   315
      Left            =   7140
      TabIndex        =   8
      Top             =   6120
      Width           =   375
   End
   Begin VB.CommandButton Command2 
      Caption         =   "+"
      Height          =   315
      Left            =   6720
      TabIndex        =   7
      Top             =   6120
      Width           =   375
   End
   Begin VB.CommandButton Command6 
      Caption         =   "TTF Texts"
      Height          =   375
      Left            =   3180
      TabIndex        =   6
      Top             =   6120
      Width           =   1275
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Circle"
      Height          =   435
      Left            =   1860
      TabIndex        =   5
      Top             =   6540
      Width           =   1275
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Texts"
      Height          =   375
      Left            =   1860
      TabIndex        =   4
      Top             =   6120
      Width           =   1275
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Points"
      Height          =   375
      Left            =   180
      TabIndex        =   3
      Top             =   6120
      Width           =   1635
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Lines"
      Height          =   435
      Left            =   180
      TabIndex        =   1
      Top             =   6540
      Width           =   1635
   End
   Begin VB.PictureBox P 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   5895
      Left            =   180
      ScaleHeight     =   391
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   515
      TabIndex        =   0
      Top             =   180
      Width           =   7755
   End
   Begin VB.Label Label2 
      Caption         =   "Zoom Commands -->"
      Height          =   255
      Left            =   5040
      TabIndex        =   9
      Top             =   6180
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   255
      Left            =   180
      TabIndex        =   2
      Top             =   7020
      Width           =   7815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' DirectCad 1.0 -  F.Guerrazzi (2001)
' fabiog2@libero.it
' http://digilander.iol.it/WarZi/default.htm

'
' Pure VB dll with almost the same DirectDraw performance
' really fast and really easy to use
'

'
' Usage:
' Once everithing has been initialized
' just send your real coordinates to the activex
' using dw[method name] to be transform them automatically into pixel
' or pix[method name] to send coords directly to pixel
' (dw will transform all double coord to single and will clip them before to put to the screen)
' (pix will draw to the same coordinate you are sending)

'
' DirectCad also has a little 3D engine to render objects quickly as wireframe
' that is not mentioned here at the moment
'


'
' If you will found this activex useful please, let me know it,
' i'll keep improving it inserting
' bitmaps and other any useful methods you would suggest to me
'

' Thank you
' Fabio Guerrazzi


Dim Paper As New CadView

Function Fmt(v As Variant) As String
  
  Fmt = Format(v, "#####0.000")
  
End Function

Private Sub Command1_Click()
 Randomize
 
 Paper.BackColor = QBColor(8)
 Paper.Cls
 
 For i = 1 To 10000
   x# = (Rnd * 5000) - 100
   y# = (Rnd * 1000) - 500
   X1# = (Rnd * 1000) - 100
   Y1# = (Rnd * 1000) - 100
   c& = Int(Rnd * 14) + 1
   Paper.dwLine x, y, X1, Y1, QBColor(c)
 Next
 
 Paper.Refresh
 
 
End Sub


Private Sub Command2_Click()
  Paper.Zoom VIEW_ZOOM_IN
  Command1_Click
End Sub

Private Sub Command3_Click()
 Randomize
 
 Paper.BackColor = QBColor(0)
 Paper.Cls
 
 For i = 1 To 10000
   x# = (Rnd * 1000) - 100
   y# = (Rnd * 1000) - 100
   c& = Int(Rnd * 14) + 1
   Paper.dwPoint x, y, QBColor(c)
 Next
 
 Paper.Refresh
 
End Sub

Private Sub Command4_Click()
 Randomize
 
 Paper.BackColor = QBColor(0)
 Paper.Cls
 
 t! = Timer
 Paper.FontName = "*VECT"
 For i& = 1 To 100
   x# = (Rnd * 1000) - 100
   y# = (Rnd * 1000) - 100
   c& = Int(Rnd * 14) + 1
   Angle! = (Rnd * 360) + 1
   tHeight# = (Rnd * 75) + 10
   Paper.dwPrint CStr(QBColor(c)), x, y, tHeight, Angle, QBColor(c)
 Next
 
 Paper.Refresh
 
 Caption = Format(Timer - t, "###0.000")
 
End Sub


Private Sub Command5_Click()
 
 Randomize
 
 Paper.BackColor = QBColor(0)
 Paper.Cls
 
 For i = 1 To 100
   x# = (Rnd * 1000) - 100
   y# = (Rnd * 1000) - 100
   c& = Int(Rnd * 14) + 1
   Radius# = Int(Rnd * 400) + 1
   Paper.dwCircle x, y, Radius, QBColor(c)
 Next
 
 Paper.Refresh
 

End Sub

Private Sub Command6_Click()
 Randomize
 
 Paper.BackColor = QBColor(0)
 Paper.Cls
 
 t! = Timer
 
 For i& = 1 To 100
   x# = (Rnd * 1000) - 100
   y# = (Rnd * 1000) - 100
   c& = Int(Rnd * 14) + 1
   Angle! = (Rnd * 360) + 1
   tHeight# = (Rnd * 75) + 10
   Paper.FontName = "Arial"
   Paper.dwPrint CStr(QBColor(c)), x, y, tHeight, Angle, QBColor(c)
 Next
 
 Paper.Refresh
 
 Caption = Format(Timer - t, "###0.000")
 
End Sub

Private Sub Command7_Click()
  
  Paper.Zoom VIEW_ZOOM_OUT
  Command1_Click

End Sub

Private Sub Form_Load()
  
  
  Paper.Init P  ' Sets the PictureBox P as destination
  
  ' set real window parameters
  ' this below will be your real coordinates
  Paper.SetBoxWindow -100, -100, 1000, 1000
  ' sets the clipper view. nothing will be draw outside these pixel coords
  Paper.SetBoxViewPort 0, 0, P.ScaleWidth, P.ScaleHeight
  
  ' now just sets all internal coefficent of transformations from real
  ' coords to pixel and from pix to real
  
  Paper.SetViewport
  
End Sub


Private Sub P_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
   
    Label1 = "East : " & Fmt(Paper.xPixToPt(x)) & "   North: " & Fmt(Paper.yPixToPt(y))
   
End Sub


