Attribute VB_Name = "Module1"
Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal Hkey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal Hkey As Long, ByVal lpSubKey As String) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal Hkey As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal Hkey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal Hkey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal Hkey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal Hkey As Long, ByVal lpValueName As String) As Long

Global SetHKey As Long, SetHDir As String, r As Long
Global SetString As String, StringVal As String

Public Const REG_SZ = 1
Public Const REG_DWORD = 4

Type dbHeader
 hdTotal As Long
 hdTime As String * 8
 hdDate As String * 10
 hdDiskID As String * 9
 hdUser As String * 20
 hdLast1 As Long
 hdLast2 As Long
 hdRegOK As String * 9
 hdSdate As String * 10
 hdNull As String * 161
End Type

Type dbRecord
 dbName As String * 20
 dbAdd1 As String * 20
 dbAdd2 As String * 20
 dbAdd3 As String * 20
 dbAdd4 As String * 6
 dbTel1 As String * 15
 dbTel2 As String * 15
 dbTel3 As String * 15
 dbTel4 As String * 15
 dbTel5 As String * 25
 dbDate As String * 10
 dbEvent As String * 2
 dbWhen As String * 2
 dbNotes As String * 52
 dbDelEv As String * 2
 End Type
 
Global hd As dbHeader, db As dbRecord
Global dbTotal, dbCurrent
Global NewDate, TempDate, DayOfWeek, LastDay, TempEdit, Cl, Pm

Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" ( _
 ByVal lpRootPathName As String, _
 ByVal lpVolumeNameBuffer As String, _
 ByVal nVolumeNameSize As Long, _
 lpVolumeSerialNumber As Long, _
 lpMaximumComponentLength As Long, _
 lpFileSystemFlags As Long, _
 ByVal lpFileSystemNameBuffer As String, _
 ByVal nFileSystemNameSize As Long) As Long
Public Function DriveInfo()

VolumeNum = Space$(15): ResStr = Space$(32)
RetVal = GetVolumeInformation("C:\", VolumeNum, Len(VolumeNum), _
 DiskId, 0, 0, ResStr, Len(ResStr))

TempId = Right(String(8, "0") + Hex$(DiskId), 8)
DriveInfo = Left(TempId, 4) + "-" + Right$(TempId, 4)
End Function

Function EnCode(TempTxT)
Dim f As Integer, Temp As String

KeyCode = 5
For f = 1 To Len(TempTxT)
                       
X = Asc(Mid(TempTxT, f, 1))
X = X + KeyCode
If X = 256 Then X = 1
   Temp = Temp & Chr(X)
Next
   EnCode = Temp
End Function

Function DeCode(TempTxT)
Dim f As Integer, Temp As String

KeyCode = 5
For f = 1 To Len(TempTxT)
                       
X = Asc(Mid(TempTxT, f, 1))
X = X - KeyCode
If X = 0 Then X = 255
   Temp = Temp & Chr(X)
Next
   DeCode = Temp
End Function

Public Sub SaveString(Hkey As Long, strPath As String, strValue As String, strdata As String)
Dim keyhand, r

r = RegCreateKey(Hkey, strPath, keyhand)
 r = RegSetValueEx(keyhand, strValue, 0, REG_SZ, ByVal strdata, Len(strdata))
  r = RegCloseKey(keyhand)

End Sub

Public Function DeleteKey(ByVal Hkey As Long, ByVal strKey As String)
Dim r As Long

r = RegDeleteKey(Hkey, strKey)

End Function

Public Function DeleteValue(ByVal Hkey As Long, ByVal strPath As String, ByVal strValue As String)
Dim keyhand As Long

r = RegOpenKey(Hkey, strPath, keyhand)
 r = RegDeleteValue(keyhand, strValue)
  r = RegCloseKey(keyhand)

End Function

Public Function GetString(Hkey As Long, strPath As String, strValue As String)
Dim lValueType As Long, keyhand As Long
Dim DataType As Long, lResult As Long
Dim StrBuf As String, lDataBufSize As Long, intZeroPos As Integer

r = RegOpenKey(Hkey, strPath, keyhand)
lResult = RegQueryValueEx(keyhand, strValue, 0&, lValueType, ByVal 0&, lDataBufSize)
If lValueType = REG_SZ Then
    StrBuf = String(lDataBufSize, " ")
lResult = RegQueryValueEx(keyhand, strValue, 0&, 0&, ByVal StrBuf, lDataBufSize)
    If lResult = ERROR_SUCCESS Then
intZeroPos = InStr(StrBuf, Chr$(0))
        If intZeroPos > 0 Then
GetString = Left$(StrBuf, intZeroPos - 1)
    Else
GetString = StrBuf
End If
    End If
        End If
        
End Function
