Imports System
Imports System.Data
Imports System.Data.OleDb

Public Class CDatabase
    Private m_strConnect As String
    Private myConnection As OLEDBConnection = Nothing
    Private mySQL As String = Nothing
    Private myConnectFlag As Boolean = False
    Public Property connectString() As String
        Get
            Return m_strConnect
        End Get
        Set
            
            m_strConnect = value
        End Set
    End Property
    
    Public Sub New()
        MyBase.New()
    End Sub
    Public Sub New(ByRef strConnect As String)
        MyBase.New()
        m_strConnect = strConnect
    End Sub
    Public Function Connect() As Boolean
        Try
            myConnection = New OleDbConnection(m_strConnect)
            myConnection.Open()
            myConnectFlag = True
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        Return myConnectFlag
    End Function
    Private Function GetTables(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT Name FROM SysObjects WHERE Type='U' "
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                mylocalDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function myDatabaseTables(ByRef myTableDataSet As DataSet) As Boolean
        Dim myLocalTableDataSet As DataSet = New DataSet()
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                Dim myDataReader As OleDbDataReader
                Dim successFlag As Boolean = False
                successFlag = GetTables(myDataReader)
                If (successFlag) Then
                    Dim myArrayList As ArrayList = New ArrayList()
                    While (myDataReader.Read())
                        Dim myTableName As String = ""
                        myTableName = CType(myDataReader.GetValue(0), String)
                        myArrayList.Add(myTableName)
                    End While
                    myDataReader.Close()
                    Dim iArrayCount As Integer = myArrayList.Count
                    Dim myTableArray(iArrayCount) As String
                    myArrayList.CopyTo(myTableArray)
                    Dim i As Integer
                    For i = 0 To iArrayCount - 1
                        Dim tblName As String
                        tblName = myTableArray(i)
                        mySQL = "sp_help " & "[" & tblName & "]"
                        Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                        Dim myDataSetCommand As OleDbDataAdapter = New OleDbDataAdapter(myCommand)
                        myDataSetCommand.Fill(myLocalTableDataSet, tblName)
                        'Dim myDataSetCommand As ADODataSetCommand = New ADODataSetCommand(myCommand)
                        'myDataSetCommand.FillDataSet(myLocalTableDataSet, tblName)
                    Next
                End If
                myTableDataSet = myLocalTableDataSet
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myTableDataSet = myLocalTableDataSet
        Return mySuccessFlag
    End Function
    Private Function GetStoredProcs(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                mySQL = "SELECT * FROM SysObjects WHERE Type='P' "
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                myDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)
                'myDataReader = mylocalDataReader
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function myDatabaseStoredProcs(ByRef myTableDataSet As DataSet) As Boolean
        Dim myLocalTableDataSet As DataSet = New DataSet()
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                Dim myDataReader As OleDbDataReader
                Dim successFlag As Boolean = False
                successFlag = GetStoredProcs(myDataReader)
                If (successFlag) Then
                    Dim myArrayList As ArrayList = New ArrayList()
                    While (myDataReader.Read())
                        Dim myTableName As String = ""
                        myTableName = CType(myDataReader.GetValue(0), String)
                        myArrayList.Add(myTableName)
                    End While
                    myDataReader.Close()
                    Dim iArrayCount As Integer = myArrayList.Count
                    Dim myTableArray(iArrayCount) As String
                    myArrayList.CopyTo(myTableArray)
                    Dim i As Integer
                    For i = 0 To iArrayCount - 1
                        Dim tblName As String
                        tblName = myTableArray(i)
                        mySQL = "sp_help " & "[" & tblName & "]"
                        Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                        Dim myDataSetCommand As OleDbDataAdapter = New OleDbDataAdapter(myCommand)
                        myDataSetCommand.Fill(myLocalTableDataSet, tblName)
                        'Dim myDataSetCommand As ADODataSetCommand = New ADODataSetCommand(myCommand)
                        'myDataSetCommand.FillDataSet(myLocalTableDataSet, tblName)
                    Next
                End If
                myTableDataSet = myLocalTableDataSet
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myTableDataSet = myLocalTableDataSet
        Return mySuccessFlag
    End Function
    Private Function GetViews(ByRef myDataReader As OleDbDataReader) As Boolean
        Dim mylocalDataReader As OleDbDataReader = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            mySQL = "SELECT * FROM SysObjects WHERE Type='V' "
            Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
            myDataReader = myCommand.ExecuteReader(CommandBehavior.SingleResult)

            mySuccessFlag = True
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myDataReader = mylocalDataReader
        Return mySuccessFlag
    End Function
    Public Function myDatabaseView(ByRef myTableDataSet As DataSet) As Boolean
        Dim myLocalTableDataSet As DataSet = New DataSet()
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                Dim myDataReader As OleDb.OleDbDataReader
                Dim successFlag As Boolean = False
                successFlag = GetViews(myDataReader)
                If (successFlag) Then
                    Dim myArrayList As ArrayList = New ArrayList()
                    While (myDataReader.Read())
                        Dim myTableName As String = ""
                        myTableName = CType(myDataReader.GetValue(0), String)
                        myArrayList.Add(myTableName)
                    End While
                    myDataReader.Close()
                    Dim iArrayCount As Integer = myArrayList.Count
                    Dim myTableArray(iArrayCount) As String
                    myArrayList.CopyTo(myTableArray)
                    Dim i As Integer
                    For i = 0 To iArrayCount - 1
                        Dim tblName As String
                        tblName = myTableArray(i)
                        mySQL = "sp_help " & "[" & tblName & "]"
                        Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                        Dim myDataSetCommand As OleDbDataAdapter = New OleDbDataAdapter(myCommand)
                        myDataSetCommand.Fill(myLocalTableDataSet, tblName)
                        'Dim myDataSetCommand As OLEDBCommand = New ADODataSetCommand(myCommand)
                        'myDataSetCommand.FillDataSet(myLocalTableDataSet, tblName)
                    Next
                End If
                myTableDataSet = myLocalTableDataSet
                mySuccessFlag = True
            End If
        Catch e As Exception
            Console.WriteLine(e.ToString())
        End Try
        myTableDataSet = myLocalTableDataSet
        Return mySuccessFlag
    End Function
    Public Sub Close()
        If myConnectFlag Then
            myConnection.Close()
        End If
    End Sub
    Public Function ExecuteSQL(ByRef mySQL As String, ByRef myDataSet As DataSet, ByRef mySQLError As String) As Boolean
        Dim mylocalDataSet As DataSet = New DataSet()
        Dim mylocalError As String = Nothing
        Dim mySuccessFlag As Boolean = False
        Try
            If (myConnectFlag) Then
                Dim myCommand As OleDbCommand = New OleDbCommand(mySQL, myConnection)
                Dim myDataSetCommand As OleDbDataAdapter = New OleDbDataAdapter(myCommand)
                myDataSetCommand.Fill(mylocalDataSet, "temp")
                'Dim myDataSetCommand As OLEDataSetCommand = New ADODataSetCommand(myCommand)
                'myDataSetCommand.FillDataSet(mylocalDataSet, "temp")
                mySuccessFlag = True
            Else

                mylocalError = "[Connection Failed]: Invalid Connection parameters."
            End If
        Catch e As OleDbException
            Dim myError As OleDbError
            For Each myError In e.Errors
                mylocalError += "[Error Source]: " + myError.Source + "[Error Message]: " + myError.Message
            Next
        Finally
            mySQLError = mylocalError
            myDataSet = mylocalDataSet
        End Try
        Return mySuccessFlag
    End Function

End Class
