VERSION 5.00
Object = "{8FD2DADC-43C7-11D4-B28B-444553540000}#1.0#0"; "PLASTICA.OCX"
Begin VB.Form CtlBez 
   Caption         =   "NURBS"
   ClientHeight    =   6900
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   6990
   LinkTopic       =   "Form1"
   ScaleHeight     =   460
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   466
   StartUpPosition =   2  'CenterScreen
   Begin Plastica.Scene3D Scene3D1 
      Height          =   5775
      Left            =   60
      TabIndex        =   8
      Top             =   1020
      Width           =   6795
      _ExtentX        =   11986
      _ExtentY        =   10186
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Auto Center"
      Height          =   315
      Left            =   5100
      TabIndex        =   0
      Top             =   60
      Width           =   1695
   End
   Begin VB.CheckBox Check3 
      Caption         =   "Show Origin"
      Height          =   195
      Left            =   180
      TabIndex        =   7
      Top             =   600
      Value           =   1  'Checked
      Width           =   2115
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   5100
      TabIndex        =   6
      Top             =   540
      Width           =   915
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Show Knots"
      Height          =   195
      Left            =   180
      TabIndex        =   5
      Top             =   360
      Value           =   1  'Checked
      Width           =   2175
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Show Grid"
      Height          =   195
      Left            =   180
      TabIndex        =   4
      Top             =   120
      Value           =   1  'Checked
      Width           =   1815
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Done"
      Height          =   315
      Left            =   6120
      TabIndex        =   3
      Top             =   540
      Width           =   855
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   3720
      TabIndex        =   1
      Text            =   "1"
      Top             =   540
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Move step"
      Height          =   195
      Left            =   2580
      TabIndex        =   2
      Top             =   600
      Width           =   1035
   End
   Begin VB.Menu Cont 
      Caption         =   "Control"
      Begin VB.Menu Rotates 
         Caption         =   "Rotate"
      End
      Begin VB.Menu SelNodo 
         Caption         =   "Select Node"
      End
      Begin VB.Menu sep 
         Caption         =   "-"
      End
      Begin VB.Menu MoveX 
         Caption         =   "Move X"
      End
      Begin VB.Menu MoveY 
         Caption         =   "Move Y"
      End
      Begin VB.Menu MoveZ 
         Caption         =   "Move Z"
      End
   End
End
Attribute VB_Name = "CtlBez"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Type Point
  x As Double
  y As Double
  z As Double
End Type

Private Type crd
  x As Single
  y As Single
End Type

Dim Knt() As Point
Dim Curk As Integer
'Dim P2D(3, 15) As crd
Dim Curi As Integer
Dim Sx As Single, Sy As Single, Bx As Single, By As Single

Dim nw As Integer, nh As Integer
Private Sub Check1_Click()
  Scene3D1.ShowGridControlBezier = Check1 = 1
  Scene3D1.DrawScene
End Sub

Private Sub Check2_Click()
Scene3D1.ShowKnotsControlBezier = Check2 = 1
Scene3D1.DrawScene
End Sub


Private Sub Check3_Click()
   Scene3D1.ShowOriginaxes = Check3 = 1
   Scene3D1.DrawScene
End Sub

Private Sub Command1_Click()
 
 Scene3D1.SaveToFile "pppp"
 Scene3D1.ClearScene
 
 Form1.D3D1.Refresh
 Form1.D3D1.InsertFile "PPPP"
 
 Kill "pppp"
 
 
 Unload Me
End Sub

Private Sub Command2_Click()
 Scene3D1.ClearScene
 Unload Me
End Sub

Private Sub Command3_Click()
 Screen.MousePointer = 11
 Scene3D1.Autocenter
 Scene3D1.DrawScene
 Screen.MousePointer = 0
End Sub

Private Sub Form_Load()
  nw = Val(InputBox("Sections number", , "1"))
 
  nh = 1
  
  If nh = 0 Or nh > 10 Or nw = 0 Or nw > 10 Then Exit Sub
  
  Screen.MousePointer = 11
  Scene3D1.ControlBezier = True
  Scene3D1.ShowGridControlBezier = True
  Scene3D1.ShowKnotsControlBezier = True
  Scene3D1.ShowOriginaxes = True
  Text1 = "0.4"
  Scene3D1.MouseAction = 0
  
  LoadSample
  AddObj
  Screen.MousePointer = 0
  
End Sub


Sub LoadSample()
  
 ' Carica i Knot iniziali per una superfice piana.
 ' il numero di patch  specificato in nh e nw
 ' che preparano i vertici per la superfice
      
 Dim fx#, fy#, i%, k%
 InitKnot
 
For k = 1 To nh
    fy = k * 30
    For i = 1 To nw
      fx = i * 30
      AddK fx - 30, fy, 0
      AddK fx - 30, fy - 10, 0
      AddK fx - 30, fy - 20, 0
      AddK fx - 30, fy - 30, 0
          
      AddK fx - 20, fy, 0
      AddK fx - 20, fy - 10, 0
      AddK fx - 20, fy - 20, 0
      AddK fx - 20, fy - 30, 0
          
      AddK fx - 10, fy, 0
      AddK fx - 10, fy - 10, 0
      AddK fx - 10, fy - 20, 0
      AddK fx - 10, fy - 30, 0
          
      AddK fx, fy, 0
      AddK fx, fy - 10, 0
      AddK fx, fy - 20, 0
      AddK fx, fy - 30, 0
    Next i
 Next k
  
  
  
  
  
Exit Sub

due:
  AddK -9, -2, 8
  AddK -4, 1, 8
  AddK 4, -3, 6
  AddK 10, -1, 8
          
  AddK -6, 3, 4
  AddK 0, -1, 4
  AddK 2, -1, 4
  AddK 6, 2, 4
          
  AddK -10, -2, -2
  AddK -4, -4, -2
  AddK 4, -1, -2
  AddK 10, 0, -2
          
  AddK -9, 2, -6
  AddK -4, -4, -5
  AddK 4, 3, -5
  AddK 9, -2, -6


End Sub
Sub AddObj()
  Scene3D1.ClearScene
  
  Dim s As Integer
  
  With Scene3D1
       .AddPrimitive "Surface1"
       .PreObj.Height = nh * 4
       .PreObj.Width = nw * 4
        For i = 0 To UBound(Knt)
          .PreObj.Addvertex3D Knt(i).x, Knt(i).y, Knt(i).z
        Next
      s = .AddSolid(.PreObj, "BezierSurface")
          .Solids(s).SetColor 62
  '  .Autocenter
  '  .DrawScene
  End With

End Sub

Sub AddK(x As Double, y As Double, z As Double)
    Curk = Curk + 1
   ' If Curk > 15 Then
   '    MsgBox "Errore di assegnazione Vertici (AddKnot)"
   '    Exit Sub
   ' End If
    ReDim Preserve Knt(Curk)
    Knt(Curk).x = x
    Knt(Curk).y = y
    Knt(Curk).z = z
    
End Sub



Sub InitKnot()
  Erase Knt
  Curk = -1
End Sub

Private Sub Form_Resize()
  Screen.MousePointer = 11
  Scene3D1.Left = 0
  Scene3D1.Width = ScaleWidth
  Scene3D1.Height = ScaleHeight - Scene3D1.Top
  Scene3D1.Autocenter
  Scene3D1.DrawScene
  Screen.MousePointer = 0
  
End Sub

Private Sub MoveX_Click()
  MoveX.Checked = True
  MoveY.Checked = False
  MoveZ.Checked = False
  Scene3D1.KntAx = 1  ' asse del Knot
End Sub


Private Sub MoveY_Click()
  MoveX.Checked = False
  MoveY.Checked = True
  MoveZ.Checked = False
  Scene3D1.KntAx = 2
End Sub


Private Sub MoveZ_Click()
  MoveX.Checked = False
  MoveY.Checked = False
  MoveZ.Checked = True
  Scene3D1.KntAx = 3
End Sub


Private Sub Rotates_Click()
   Scene3D1.MouseAction = 0
End Sub

Private Sub Scene3D1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button = 2 Then PopupMenu Cont
End Sub


Private Sub SelNodo_Click()
  Scene3D1.MouseAction = 3
  Scene3D1.SelectionMode = 3
End Sub


Private Sub Text1_Change()
  Scene3D1.KntStep = Val(Text1)
End Sub


