VERSION 5.00
Object = "{7DE7D2BC-D44D-4C09-9F28-56753A3544A9}#1.0#0"; "Spectre.ocx"
Begin VB.Form Form1 
   Caption         =   "Spectrum Test"
   ClientHeight    =   3600
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   ScaleHeight     =   3600
   ScaleWidth      =   4455
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer3 
      Enabled         =   0   'False
      Interval        =   300
      Left            =   3420
      Top             =   1500
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Auto"
      Height          =   195
      Left            =   2040
      TabIndex        =   9
      Top             =   2280
      Width           =   795
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Loop Colors"
      Height          =   255
      Left            =   2520
      TabIndex        =   8
      Top             =   2640
      Width           =   1455
   End
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   3900
      Top             =   960
   End
   Begin VB.Timer Timer1 
      Left            =   3420
      Top             =   960
   End
   Begin VB.Frame Frame1 
      Height          =   2055
      Left            =   60
      TabIndex        =   6
      Top             =   60
      Width           =   3195
      Begin Spectre.Spectrum Spectrum1 
         Height          =   1755
         Left            =   60
         TabIndex        =   10
         Top             =   180
         Width           =   3015
         _ExtentX        =   5318
         _ExtentY        =   3096
      End
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   195
      Left            =   1200
      Max             =   25
      Min             =   10
      TabIndex        =   4
      Top             =   2640
      Value           =   15
      Width           =   1155
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Analyzer"
      Height          =   315
      Left            =   1020
      TabIndex        =   3
      Top             =   2220
      Width           =   975
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Lines"
      Height          =   315
      Left            =   120
      TabIndex        =   2
      Top             =   2220
      Width           =   855
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Stop"
      Height          =   315
      Left            =   3420
      TabIndex        =   1
      Top             =   540
      Width           =   975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   315
      Left            =   3420
      TabIndex        =   0
      Top             =   180
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   " Fabio Guerrazzi 2001 - www.digilander.iol.it/WarZi/default.htm"
      Height          =   375
      Left            =   180
      TabIndex        =   7
      Top             =   3060
      Width           =   3855
   End
   Begin VB.Shape Shape1 
      Height          =   495
      Left            =   120
      Top             =   3000
      Width           =   4275
   End
   Begin VB.Label Label1 
      Caption         =   "Fader Power"
      Height          =   195
      Left            =   120
      TabIndex        =   5
      Top             =   2640
      Width           =   1155
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'################################################################################
'#                                                                              #
'#  Spectrum OCX native VB6 Code                                                #
'#  Authors: Fabio Guerrazzi                                                    #
'#         : Scott Fitzhugh                                                     #
'#  Date: March 08, 2001                                                        #
'#                                                                              #
'#  Fabio Guerrazzi-    fabiog2@libero.it                                       #
'#  Scott Fitzhugh -    arsecannon@yahoo.com                                    #
'#                                                                              #
'#                                                                              #
'#  2001 - Fabio Guerrazzi - http://digilander.iol.it/WarZi/default.htm        #
'#  2000 - Scott Fitzhugh  - http://www.themeshops.com                         #
'################################################################################

Private Sub Command1_Click()

  Spectrum1.StartWatch
  
  Timer1.Interval = 1000
  If Check1 = 1 Then Timer2.Enabled = True  ' Loop Colors
  If Check2 = 1 Then Timer3.Enabled = True  ' Auto Fake Analyzer
  
End Sub


Private Sub Command2_Click()
  Spectrum1.StopWatch
  Timer1.Interval = 0
  Timer2.Enabled = False
  Timer3.Enabled = False
End Sub


Private Sub Command3_Click()

' Spectrum1.SetLine 1, 25, 100, 25
' Exit Sub
' a random line
 
 Randomize
 
 With Spectrum1
     w! = .SpectrumWidth
     H! = .SpectrumHeight
   For i = 1 To 15
       X2! = (w * Rnd) + 1
       Y2! = (H * Rnd) + 1
       If i = 1 Then
          X1! = X2
          Y1! = Y2
       Else
         .SetLine X1, Y1, X2, Y2
          X1! = X2
          Y1! = Y2
       End If
   Next
 End With
 
End Sub

Private Sub Command4_Click()
 Dim f As Single, H As Single
 Dim j As Single

crazy = 15  'change crazy to get a more wild analyzer pattern (higher more energy)

Randomize

Dim stp!

H = 25
f = 25

 With Spectrum1
     w! = .SpectrumWidth
     hg! = .SpectrumHeight


For j = 1 To w
    If (j - 10) >= 0 Then
        f = Int((H + crazy) - (H - crazy) + 1) * Rnd + (H - crazy)
    Else
        f = Int(crazy + 1) * Rnd
    End If
    
    If f <= hg And H <= hg Then
       If f > H Then stp = -1 Else stp = 1
       
       For x = j - 1 To j
          For y = f To H Step stp
            If x >= 0 And x <= w And y >= 0 And y <= hg Then
               .SetLine j, f, j - 1, H
            End If
          Next
       Next
            
    End If
    H = f
Next j

End With

End Sub

Private Sub HScroll1_Change()
  Spectrum1.FadeWidth = HScroll1
End Sub


Private Sub Spectrum1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  Spectrum1.SetPoint x, y
End Sub


Private Sub Spectrum1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
 Spectrum1.SetPoint x, y
End Sub


Private Sub Timer1_Timer()
 Caption = "Frame Rate: " & CStr(Spectrum1.FrameRate)
End Sub


Private Sub Timer2_Timer()
' loop random colors
 
 Dim Fc As Integer
 Dim Tc As Integer
 
 If Check1 = 0 Then Exit Sub
 
 Randomize
 
 Fc = Int(Rnd * 15) + 0
 Tc = Int(Rnd * 15) + 0
 Spectrum1.SetPalette QBColor(Fc), QBColor(Tc)
 
End Sub


Private Sub Timer3_Timer()
If Check2 = 0 Then Exit Sub
Command4_Click
End Sub


